#include "c3ds.h"
#include <stdio.h>
#include <assert.h>
char gVersion[] = "(c) Andrea Ingegneri 2001";


void C3dsFileLoader::UserRGBF(float r, float g, float b)
{
	//cout << "red: " << r << "green: " << g << "blue: " << b << endl;
}

void C3dsFileLoader::UserObjName(string Name)
{
	//cout << "Object Name: " << Name << endl;
}

void C3dsFileLoader::User3dVert(float x, float y, float z)
{
	//cout << "X: " << x << " Y: " << y << " Z:" << z << endl;
}

void C3dsFileLoader::User3dFace(unsigned short A, unsigned short B, unsigned short C, unsigned short Flags)
{
	//cout << "A: " << A << " B: " << B << " C:" << C << endl;
	//cout << " Flags: " << Flags << endl;
}

void C3dsFileLoader::UserTriMesh()
{
}


void C3dsFileLoader::UserCamera(float px, float py, float pz,
								float tx, float ty, float tz,
								float Bank, float Lens)
{
	//cout << "Position: X:" << px << "Y: " << py << "Z: " << pz << endl;
	//cout << "Target: X:" << tx << "Y: " << ty << "Z: " << tz << endl;
	//cout << "Bank: " << Bank << endl;
	//cout << "Lens: " << Lens << endl;
}

void C3dsFileLoader::UserMaterial()
{
}


void C3dsFileLoader::UserFaceMaterial(string Name, int Number)
{
	//cout << "Name: " << Name << endl;
	//cout << "Face Number: " << Number << endl;
}

void C3dsFileLoader::UserFaceSmoothGroup(unsigned int smoothRef)
{
	// smoothRef is a bit pattern.
	// 32 smooth groups to choose from
	//cout << "smoothRef: " << smoothRef << endl;
}

void C3dsFileLoader::UserMapVertex(float U, float V)
{
	//cout << "U: " << U << " V: " << V << endl;
}

void C3dsFileLoader::UserTransformMatrix(const Transform3dsMatrix &Transform, const Translate3dsMatrix &Translate)
{
	//cout << "Transformation Matrix:" << endl;
	//cout << Transform._11 << " " << Transform._12 << " " << Transform._13 << " " << endl;
	//cout << Transform._21 << " " << Transform._22 << " " << Transform._23 << " " << endl;
	//cout << Transform._31 << " " << Transform._32 << " " << Transform._33 << " " << endl;
	//cout << "Translation Matrix:" << endl;
	//cout << Translate._11 << " " << Translate._12 << " " << Translate._13 << " " << endl;
}

void C3dsFileLoader::UserLight(float x, float y, float z)
{
	//cout << "X: " << x << " Y: " << y << " Z: " << z << endl;
}

void C3dsFileLoader::UserSpotLight(float x, float y, float z, float HotSpot, float FallOff)
{
	//cout << "X: " << x << " Y: " << y << " Z: <" << z << endl;
	//cout << "HotSpot: " << HotSpot << endl;
	//cout << "FallOff: " << FallOff << endl;
}

void C3dsFileLoader::UserSetSpotRectangular()
{
	//cout << "square spot" << endl;
}

void C3dsFileLoader::UserSpotRoll(float roll)
{
	//cout << "spot roll: " << roll << endl;
}

void C3dsFileLoader::UserSpotAspect(float aspect)
{
	//cout << "spot aspect: " << aspect << endl;
}

void C3dsFileLoader::UserInnerRange(float inner)
{
	//cout << "InnerRange: " << inner << endl;
}

void C3dsFileLoader::UserOuterRange(float outer)
{
	//cout << "OuterRange: " << outer << endl;
}

void C3dsFileLoader::UserMatName(const string Name)
{
	//cout << "Material Name: " << Name << endl;
}

void C3dsFileLoader::UserMapFile(const string FileName)
{
	//cout << "Texture FileName: " << FileName << endl;
}

void C3dsFileLoader::UserFrames(long Start, long End)
{
	//cout << "Start: " << Start << " End: " << End << endl;
}

void C3dsFileLoader::UserTrackObjectName(string Name, int Key1, int Key2, int Key3)
{
	//cout << "Track Object Name: " << Name << endl;
	//cout << "First Key: " << Key1 << endl;
	//cout << "Second Key: " << Key2 << endl;
	//cout << "Third Key: " << Key3 << endl;
}

void C3dsFileLoader::UserTrackInstName( const string trackInstName )
{
	//cout << "Track Instance Name: " << trackInstName << endl;
}

void C3dsFileLoader::UserPivotPoint(float PivX, float PivY, float PivZ)
{
	//cout << "PivotPoint - X: " << PivX << " Y: " << PivY << " Z: " << PivZ << endl;
}

void C3dsFileLoader::UserTrackPos(int Frame, float t, float c, float b, float et, float ef, float x, float y, float z)
{
	//cout << "Frame Number: " << Frame << endl;
	//cout << "tension: " << t << " continuity: " << c << " bias: " << b << endl;
	//cout << "easeto: " << et << " easefrom: " << ef << endl;
	//cout << "Position - X: " << x << " Y: " << y << " Z: " << z << endl;
}

void C3dsFileLoader::UserTrackRot(int Frame, float t, float c, float b, float et, float ef, float x, float y, float z, float w)
{
	//cout << "Frame Number: " << Frame << endl;
	//cout << "tension: " << t << " continuity: " << c << " bias: " << b << endl;
	//cout << "easeto: " << et << " easefrom: " << ef << endl;
	//cout << "Rotation - X: " << x << " Y: " << y << " Z: " << z << " W: " << w << endl;
}

void C3dsFileLoader::UserTrackScale(int Frame, float t, float c, float b, float et, float ef, float ScaleX, float ScaleY, float ScaleZ)
{
	//cout << "Frame Number: " << Frame << endl;
	//cout << "tension: " << t << " continuity: " << c << " bias: " << b << endl;
	//cout << "easeto: " << et << " easefrom: " << ef << endl;
	//cout << "Scaling - X: " << ScaleX << " Y: " << ScaleY << " Z: " << ScaleZ << endl;
}

void C3dsFileLoader::UserTrackFov(int Frame, float t, float c, float b, float et, float ef, float fov)
{
	//cout << "Frame Number: " << Frame << endl;
	//cout << "tension: " << t << " continuity: " << c << " bias: " << b << endl;
	//cout << "easeto: " << et << " easefrom: " << ef << endl;
	//cout << "Fov - : " << fov << endl;
}

void C3dsFileLoader::UserTrackRoll(int Frame, float t, float c, float b, float et, float ef, float roll)
{
	//cout << "Frame Number: " << Frame << endl;
	//cout << "tension: " << t << " continuity: " << c << " bias: " << b << endl;
	//cout << "easeto: " << et << " easefrom: " << ef << endl;
	//cout << "Roll - : " << roll << endl;
}

void C3dsFileLoader::UserTrackHotSpot(int Frame, float t, float c, float b, float et, float ef, float hotspot)
{
	//cout << "Frame Number: " << Frame << endl;
	//cout << "tension: " << t << " continuity: " << c << " bias: " << b << endl;
	//cout << "easeto: " << et << " easefrom: " << ef << endl;
	//cout << "HotSpot - : " << hotspot << endl;
}

void C3dsFileLoader::UserTrackFallOff(int Frame, float t, float c, float b, float et, float ef, float falloff)
{
	//cout << "Frame Number: " << Frame << endl;
	//cout << "tension: " << t << " continuity: " << c << " bias: " << b << endl;
	//cout << "easeto: " << et << " easefrom: " << ef << endl;
	//cout << "FallOff - : " << falloff << endl;
}

void C3dsFileLoader::UserObjNumber(int ObjNumber)
{
	//cout << "Object Number: " << ObjNumber << endl;
}

void C3dsFileLoader::UserChunkObj()
{
}

void C3dsFileLoader::UserEndOfFile()
{
	//cout << "EndOfFile" << endl;
}

void C3dsFileLoader::UserOneUnit(float Unit)
{
	//cout << "One Unit is: " << Unit << endl;
}

void C3dsFileLoader::UserViewPortLayout(ViewPortLayout &Layout)
{
	//cout << "Style: " << Layout.style << endl;
	//cout << "Active: " << Layout.active << endl;
	//cout << "Unknow1: " << Layout.unknow1 << endl;
	//cout << "Swap: " << Layout.swap<< endl;
	//cout << "Unknow2: " << Layout.unknow2 << endl;
	//cout << "Swap Prior: " << Layout.swap_prior << endl;
	//cout << "Swap View: " << Layout.swap_view << endl;
}

void C3dsFileLoader::UserViewPortSize(int PosX, int PosY, int Width, int Height)
{
	//cout << "Position X: " << PosX << endl;
	//cout << "Position Y: " << PosY << endl;
	//cout << "Width: " << PosY << endl;
	//cout << "Height: " << PosY << endl;
}

void C3dsFileLoader::UserViewPortData(ViewPortData &Data)
{
	//cout << "Flags: " << Data.flags << endl;
	//cout << "Axis Lockout: " << Data.axis_lockout << endl;
	//cout << "Window Position - X: " << Data.win_x << " Y: " << Data.win_y << endl;
	//cout << "Window Size - Width: " << Data.win_w << " Height: " << Data.win_h << endl;
	//cout << "Window View: " << Data.win_view << endl;
	//cout << "Zoom factor: " << Data.zoom << endl;
	//cout << "World Origin - X: " << Data.worldcenter_x << " Y: " << Data.worldcenter_y << " Z: " << Data.worldcenter_z << endl;
	//cout << "Horizontal Angle: " << Data.horiz_ang << endl;
	//cout << "Vertical Angle: " << Data.vert_ang << endl;
	//cout << "Camera Name: " << Data.camera_name << endl;	
}

void C3dsFileLoader::UserViewUser(float x, float y, float z, float Width, float XYangle, float YZangle, float BackAngle)
{
	//cout << "Point - X: " << x << " Y: " << y << " Z: " << z << endl;
	//cout << "Width: " << Width << endl;
	//cout << "Horizontal view Angle from OXY Plane: " << XYangle << endl;
	//cout << "Vertical view Angle from OYZ Plane: " << YZangle << endl;
	//cout << "BankAngle of View Rotation: " << BackAngle << endl;
}

void C3dsFileLoader::UserViewCamera(string CameraName)
{
	//cout << "Default Camera Name: " << CameraName << endl;
}

void C3dsFileLoader::movePC(unsigned int forward)
{
	PC += forward;
	mInputFile.seekg(PC);
}

void C3dsFileLoader::ReadRGBF()
{
    float c[3];
    if (!ReadBlock((char *) c, sizeof(c))) 
		return;
	 UserRGBF(c[0], c[1], c[2]);
}

void C3dsFileLoader::ReadRGBB()
{
	unsigned char c[3];
	if(!ReadBlock((char *) c, sizeof(c)))
		return;
}

void C3dsFileLoader::ReadObjBlock()
{
	char ObjName[255];
	ReadASCIIZ(ObjName);
	UserObjName(string(ObjName));
}

void C3dsFileLoader::ReadTriMesh()
{
	UserTriMesh();
}

void C3dsFileLoader::ReadCamera()
{
    float c[8];
    if (!ReadBlock( (char *) c, sizeof(c)))
		return;
	UserCamera(c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7]);
}

void C3dsFileLoader::ReadMaterial()
{
	UserMaterial();
}

void C3dsFileLoader::ReadFaceMat()
{
	unsigned short n, nf;
	char MaterialName[255];

	ReadASCIIZ(MaterialName);

	if (!ReadBlock((char *) &n, sizeof(n))) 
		return;
	while (n-- > 0) 
	{	// Material number assigned to any face
		// Numero di material assegnato ad ogni faccia
		if (!ReadBlock((char*) &nf, sizeof(nf)))
			return;
		UserFaceMaterial(string(MaterialName), (int) nf);
	}
}

void C3dsFileLoader::ReadSmoothList(const unsigned int size_chnk_data)
{
	assert((size_chnk_data&0x3) == 0);	// assert a multiple of 4
	unsigned int sg, n=size_chnk_data>>2;
	
	while (n-- > 0) 
	{	// smoothgroup props assigned to any face
		if (!ReadBlock((char*) &sg, sizeof(sg)))	// sizeof(sg) must be 4!!!
			return;

		UserFaceSmoothGroup(sg);
	}
}

void C3dsFileLoader::ReadFrames()
{
    long c[2];
    if (!ReadBlock((char*) c, sizeof(c)))
		return;
	UserFrames(c[0], c[1]);
}

void C3dsFileLoader::ReadLight()
{
    float c[3];
    if (!ReadBlock( (char*) c, sizeof(c))) 
		return;
	UserLight(c[0], c[1], c[2]);
}

void C3dsFileLoader::ReadMapFile()
{
	char fileName[255];
	ReadASCIIZ(fileName);
	UserMapFile(string(fileName));
}

void C3dsFileLoader::ReadMapList()
{
    unsigned short nv;
    float c[2];

    if (!ReadBlock((char *) &nv, sizeof(nv))) 
		return;
    while (nv-- > 0) 
	{
        if (!ReadBlock((char *) c, sizeof(c)))
			return;
		UserMapVertex(c[0], c[1]);
    }
}

void C3dsFileLoader::ReadMatName()
{
	char	matName[255];

	ReadASCIIZ(matName);
	UserMatName(string(matName));
}

void C3dsFileLoader::ReadObjNumber()
{
    signed short n;

    if (!ReadBlock((char *) &n, sizeof(n)))
		return;
	UserObjNumber((int) n);
}

void C3dsFileLoader::ReadSpotLight()
{
    float c[5];
    if (!ReadBlock( (char*) c, sizeof(c)))
		return;
	UserSpotLight(c[0], c[1], c[2], c[3], c[4]);
}

void C3dsFileLoader::ReadSpotRectangular()
{
	UserSetSpotRectangular();
}

void C3dsFileLoader::ReadSpotRoll()
{
	float roll;
	if (!ReadBlock( (char*) &roll, sizeof(float)))
		return;
	UserSpotRoll(roll);
}

void C3dsFileLoader::ReadSpotAspect()
{
	float aspect;
	if (!ReadBlock( (char*) &aspect, sizeof(float)))
		return;
	UserSpotAspect(aspect);
}

void C3dsFileLoader::ReadInnerRange()
{
	float inner;
	if (!ReadBlock( (char*) &inner, sizeof(float)))
		return;
	UserInnerRange(inner);
}

void C3dsFileLoader::ReadOuterRange()
{
	float outer;
	if (!ReadBlock( (char*) &outer, sizeof(float)))
		return;
	UserOuterRange(outer);
}

void C3dsFileLoader::ReadTrackObjName()
{
    unsigned short w[2];
	short value;
	char trackName[255];

	// Read ASCIIZ name
	ReadASCIIZ(trackName);
    if (!ReadBlock((char*) w, sizeof(w))) 
		return;
	if (!ReadBlock((char*) &value, sizeof(value))) 
		return;
	UserTrackObjectName(string(trackName), w[0], w[1], value);
}

void C3dsFileLoader::ReadTrackInstName()
{
	char trackInstName[255];
	// Read ASCIIZ name
	ReadASCIIZ(trackInstName);
	UserTrackInstName( string(trackInstName) );
}

void C3dsFileLoader::ReadPivotPoint()
{
	float pivot[3];
	 if (!ReadBlock((char*) pivot, sizeof(pivot))) 
		return;

	UserPivotPoint(pivot[0], pivot[1], pivot[2]);
}

void C3dsFileLoader::ReadTrack(unsigned short Flag)
{
	short	n, nf;
	float key_data[4];	// 4 is max
	
	// determine number of floats in every key
	long dim_key=0;
	switch(Flag)
	{
		case CHUNK_TRACKFOV:
		case CHUNK_TRACKROLL:
		case CHUNK_TRACKHOTSPOT:
		case CHUNK_TRACKFALLOFF:
			dim_key = 1;
			break;
		case CHUNK_TRACKPOS:
		case CHUNK_TRACKSCALE:
			dim_key = 3;
			break;
		case CHUNK_TRACKROTATE:
			dim_key = 4;
			break;
		default:
			assert(false);	// can't ID trackanim type
	}

	// read data
	mInputFile.seekg(10, ios::cur);
	PC += 10;
    if(!ReadBlock( (char*) &n, sizeof(n))) 
		return;
	mInputFile.seekg(2, ios::cur);
	PC += 2;
    while (n-- > 0) 
	{
			const int tension_detect = 1<<16;
			const int continuity_detect = 1<<17;
			const int bias_detect = 1<<18;
			const int easeto_detect = 1<<19;
			const int easefrom_detect = 1<<20;
		
        int i;
		  long flags;
        float dat;
		  float tens=0, cont=0, bias=0, easeto=0, easefrom=0;
        if (!ReadBlock( (char *) &nf, sizeof(nf))) 
			return;
        if (!ReadBlock((char *) &flags, sizeof(flags))) 
			return;
        for (i = 0; i < 32; i++)
            if (flags & (1 << i))
				{
                if (!ReadBlock( (char *) &dat, sizeof(dat))) 
						return;

					// fetch controller data
					switch((1 << i))
					{
						case tension_detect:
							tens = dat;
							break;
						case continuity_detect:
							cont = dat;
							break;
						case bias_detect:
							bias = dat;
							break;
						case easeto_detect:
							easeto = dat;
							break;
						case easefrom_detect:
							easefrom = dat;
							break;
					}
				}
		  
		  // read key
        if (!ReadBlock( (char *) key_data, dim_key*sizeof(float)))
			return;

		  // distribute current key
		switch(Flag)
		{
			case CHUNK_TRACKFOV:
				UserTrackFov(nf, tens, cont, bias, easeto, easefrom, key_data[0]);
				break;
			case CHUNK_TRACKROLL:
				UserTrackRoll(nf, tens, cont, bias, easeto, easefrom, key_data[0]);
				break;
			case CHUNK_TRACKHOTSPOT:
				UserTrackHotSpot(nf, tens, cont, bias, easeto, easefrom, key_data[0]);
				break;
			case CHUNK_TRACKFALLOFF:
				UserTrackFallOff(nf, tens, cont, bias, easeto, easefrom, key_data[0]);
				break;
			case CHUNK_TRACKPOS:
				UserTrackPos(nf, tens, cont, bias, easeto, easefrom, key_data[0], key_data[1], key_data[2]);
				break;
			case CHUNK_TRACKSCALE:
				UserTrackScale(nf, tens, cont, bias, easeto, easefrom, key_data[0], key_data[1], key_data[2]);
				break;
			case CHUNK_TRACKROTATE:
				UserTrackRot(nf, tens, cont, bias, easeto, easefrom, key_data[1], key_data[2], key_data[3], key_data[0]);
				break;
			default:
				assert(false);	// can't ID trackanim type
		}
    }
}

void C3dsFileLoader::ReadTrMatrix()
{
    float rot[9];
    float trans[3];
    if (!ReadBlock((char *) rot, sizeof(rot)))
		return;
    if (!ReadBlock( (char *) trans, sizeof(trans)))
		return;
	Transform3dsMatrix Transform;
	Translate3dsMatrix Translate;
	Transform._11 = rot[0]; Transform._12 = rot[1]; Transform._13 = rot[2];
	Transform._21 = rot[3]; Transform._22 = rot[4]; Transform._23 = rot[5];
	Transform._31 = rot[6]; Transform._32 = rot[7]; Transform._33 = rot[8];
	Translate._11 = trans[0]; Translate._12 = trans[1]; Translate._13 = trans[2];
	UserTransformMatrix(Transform, Translate);
}

void C3dsFileLoader::ReadVertList()
{
   unsigned short nv;
   float c[3];

   if (!ReadBlock((char *) &nv, 2))
		return;
   while (nv-- > 0)
	{
		if (!ReadBlock((char *) c, sizeof(c)))
			return;
		User3dVert(c[0], c[1], c[2]);
   }
}

void C3dsFileLoader::ReadFaceList()
{
    unsigned short nv;
    unsigned short c[4];

    if (!ReadBlock((char *) &nv, sizeof(nv)))
		return;
   while (nv-- > 0)
	{
		if (!ReadBlock((char *) c, sizeof(c)))
			return;
		User3dFace(c[0], c[1], c[2], c[3]);
	}
}

void C3dsFileLoader::ReadObjChunk()
{
	UserChunkObj();
}

void C3dsFileLoader::EndReading()
{
	UserEndOfFile();
}

void C3dsFileLoader::ReadOneUnit()
{
	float OneUnit;
    if (!ReadBlock((char *) &OneUnit, sizeof(OneUnit)))
		return;
	UserOneUnit(OneUnit);
}

void C3dsFileLoader::ReadViewPortLayout()
{
    unsigned short	style;
    short			active, unknow1, swap, unknow2, swap_prior, swap_view;

	if (!ReadBlock((char *) &style, sizeof(style)))
		return;
    if (!ReadBlock((char *) &active, sizeof(active)))
		return;
    if (!ReadBlock((char *) &unknow1, sizeof(unknow1)))
		return;
    if (!ReadBlock((char *) &swap, sizeof(swap)))
		return;
    if (!ReadBlock((char *) &unknow2, sizeof(unknow2)))
		return;
    if (!ReadBlock((char *) &swap_prior, sizeof(swap_prior)))
		return;
    if (!ReadBlock((char *) &swap_view, sizeof(swap_view)))
		return;
	 ViewPortLayout vp = ViewPortLayout(style, active, unknow1, swap, unknow2, swap_prior, swap_view);
	 UserViewPortLayout(vp);
}

void C3dsFileLoader::ReadViewPortSize()
{
	short PosX, PosY, Width, Height; 
	if (!ReadBlock((char *) &PosX, sizeof(PosX)))
		return;
	if (!ReadBlock((char *) &PosY, sizeof(PosY)))
		return;
	if (!ReadBlock((char *) &Width, sizeof(Width)))
		return;
	if (!ReadBlock((char *) &Height, sizeof(Height)))
		return;
	UserViewPortSize(PosX, PosY, Width, Height);
}

void C3dsFileLoader::ReadViewPortData()
{
	short flags, axis_lockout;
    short win_x, win_y, win_w, win_h, win_view;
	float zoom; 
	float worldcenter_x, worldcenter_y, worldcenter_z;
	float horiz_ang, vert_ang;
	char camera_name[12];

	if (!ReadBlock((char *) &flags, sizeof(flags)))
		return;
	if (!ReadBlock((char *) &axis_lockout, sizeof(axis_lockout)))
		return;
	if (!ReadBlock((char *) &win_x, sizeof(win_x)))
		return;
	if (!ReadBlock((char *) &win_y, sizeof(win_y)))
		return;
	if (!ReadBlock((char *) &win_w, sizeof(win_w)))
		return;
	if (!ReadBlock((char *) &win_h, sizeof(win_h)))
		return;
	if (!ReadBlock((char *) &win_view, sizeof(win_view)))
		return;
	if (!ReadBlock((char *) &zoom, sizeof(zoom)))
		return;
	if (!ReadBlock((char *) &worldcenter_x, sizeof(worldcenter_x)))
		return;
	if (!ReadBlock((char *) &worldcenter_y, sizeof(worldcenter_y)))
		return;
	if (!ReadBlock((char *) &worldcenter_z, sizeof(worldcenter_z)))
		return;
	if (!ReadBlock((char *) &horiz_ang, sizeof(horiz_ang)))
		return;
	if (!ReadBlock((char *) &vert_ang, sizeof(vert_ang)))
		return;
	if (!ReadBlock((char *) camera_name, CameraNameSize))
		return;

	ViewPortData vd = ViewPortData(flags, axis_lockout, win_x, win_y, win_w, win_h,
								  win_view, zoom, worldcenter_x, worldcenter_y,
								  worldcenter_z, horiz_ang, vert_ang, camera_name);
	UserViewPortData(vd);
}

void C3dsFileLoader::ReadViewUser()
{
	float c[3];
	float Width, XYangle, YZangle, BackAngle;

	if (!ReadBlock((char *) c, sizeof(c)))
		return;
	if (!ReadBlock((char *) &Width, sizeof(Width)))
		return;
	if (!ReadBlock((char *) &XYangle, sizeof(XYangle)))
		return;
	if (!ReadBlock((char *) &YZangle, sizeof(YZangle)))
		return;
	if (!ReadBlock((char *) &BackAngle, sizeof(BackAngle)))
		return;
	UserViewUser(c[0], c[1], c[2], Width, XYangle, YZangle, BackAngle);
}

void C3dsFileLoader::ReadViewCamera()
{
	char camera_name[12];

	if (!ReadBlock((char *) camera_name, CameraNameSize))
		return;
	UserViewCamera(string(camera_name));

}

bool C3dsFileLoader::ParseChunks()
{
	if(!mInputFile.is_open())
		return false;
	if(mInputFile.eof())
		return false;
	
	int level = 0, endPos;
	mInputFile.seekg(0, ios::end);
	endPos = mInputFile.tellg();
	mInputFile.seekg(0, ios::beg);
	bool bRes = ParseSubChunks(endPos, level);

	assert(endPos == mInputFile.tellg());

	return bRes;
}

bool C3dsFileLoader::ParseSubChunks(int endPos, const int level)
{
	while(PC != endPos)
	{
		chunk3ds	chunk;
		if(!ReadBlock((char*) &chunk, sizeof(chunk3ds)))
			return false;

		const int newEndPos = PC + (chunk.Size - sizeof(chunk3ds));
		const int newLevel = level + 1;

		switch(chunk.Flag)
		{
			case CHUNK_RGBF:
				//cout << "Chunk RGBF detected" << endl;
				ReadRGBF();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_RGBB:
				//cout << "Chunk RGBB detected" << endl;
				ReadRGBB();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_MAIN:
				//cout << "Chunk Main detected" << endl;
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_OBJMESH:
				//cout << "Chunk Object detected" << endl;
				ReadObjChunk();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_OBJBLOCK:
				//cout << "Chunk Object Block detected" << endl;
				ReadObjBlock();
				//cout << endl;
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRIMESH:
				//cout << "Chunk Trimesh detected" << endl;
				ReadTriMesh();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_VERTLIST:
				//cout << "Chunk VertList detected at " << (PC - sizeof(chunk3ds)) << endl;
				ReadVertList();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_FACELIST:
				//cout << "Chunk FaceList detected" << endl;
				ReadFaceList();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_FACEMAT:
				//cout << "Chunk FaceMat detected" << endl;
				ReadFaceMat();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_MAPLIST:
				//cout << "Chunk MapList detected" << endl;
				ReadMapList();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_SMOOLIST:
				//cout << "Chunk SmoothList detected" << endl;
				ReadSmoothList(chunk.Size - sizeof(chunk3ds));
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRMATRIX:
				//cout << "Chunk TRMatrix detected" << endl;
				ReadTrMatrix();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_LIGHT:
				//cout << "Chunk Light detected" << endl;
				PushMode(LIGHT_PARSE);
				ReadLight();
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_SPOTLIGHT:
				//cout << "Chunk SpotLight detected" << endl;
				ReadSpotLight();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_SPOT_RECTANGULAR:
				//cout << "Chunk SpotRectangular detected" << endl;
				ReadSpotRectangular();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_SPOT_ROLL:
				//cout << "Chunk SpotRoll detected" << endl;
				ReadSpotRoll();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_SPOT_ASPECT:
				//cout << "Chunk SpotAspect detected" << endl;
				ReadSpotAspect();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_INNER_RANGE:
				//cout << "Chunk inner range detected" << endl;
				ReadInnerRange();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_OUTER_RANGE:
				//cout << "Chunk outer range detected" << endl;
				ReadOuterRange();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_CAMERA:
				//cout << "Chunk Camera detected" << endl;
				ReadCamera();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_MATERIAL:
				//cout << "Chunk Material detected" << endl;
				ReadMaterial();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_MATNAME:
				//cout << "Chunk MatName detected" << endl;
				ReadMatName();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_DIFFUSE_MAP:
				//cout << "Chunk Diffuse detected" << endl;
				PushMode(DIFFUSE_PARSE);
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_SPECULAR_MAP:
				//cout << "Chunk Specular detected" << endl;
				PushMode(SPECULAR_PARSE);
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_REFLECTION_MAP:
				//cout << "Chunk Reflection detected" << endl;
				PushMode(REFLECTION_PARSE);
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_BUMPMAP_MAP:
				//cout << "Chunk Bumpmap detected" << endl;
				PushMode(BUMPMAP_PARSE);
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_MAPFILE:
				//cout << "Chunk MapFile detected" << endl;
				ReadMapFile();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_FRAMES:
				//cout << "Chunk Frames detected" << endl;
				ReadFrames();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_KEYFRAMER:
				//cout << "Chunk Keyframer detected" << endl;
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRACKINFO:
				//cout << "Chunk TrackInfo detected" << endl;
				PushMode(TRACKINFO_PARSE);
				UserTrackInfo();
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_TRACKCAMERA:
				//cout << "Chunk TrackCamera detected" << endl;
				PushMode(TRACKCAMERA_PARSE);
				UserTrackCamera();
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_TRACKCAMTGT:
				//cout << "Chunk TrackCameraTgt detected" << endl;
				PushMode(TRACKCAMTGT_PARSE);
				UserTrackCamTgt();
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_TRACKLIGHT:
				//cout << "Chunk TrackLight detected" << endl;
				PushMode(TRACKLIGHT_PARSE);
				UserTrackLight();
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_TRACKLIGTTGT:
				//cout << "Chunk TrackLightTgt detected" << endl;
				PushMode(TRACKLIGHTTGT_PARSE);
				UserTrackLightTgt();
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_TRACKSPOTL:
				//cout << "Chunk TrackSpot detected" << endl;
				PushMode(TRACKSPOTL_PARSE);
				UserTrackSpotL();
				ParseSubChunks(newEndPos, newLevel);
				PopMode();
				break;
			case CHUNK_TRACKOBJNAME:
				//cout << "Chunk TrackObjName detected" << endl;
				ReadTrackObjName();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRACKINSTNAME:
				//cout << "Chunk TrackInstName detected" << endl;
				ReadTrackInstName();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRACKPOS:
				//cout << "Chunk TrackPos detected" << endl;
				ReadTrack(CHUNK_TRACKPOS);
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRACKROTATE:
				//cout << "Chunk TrackRotate detected" << endl;
				ReadTrack(CHUNK_TRACKROTATE);
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRACKSCALE:
				//cout << "Chunk TrackScale detected" << endl;
				ReadTrack(CHUNK_TRACKSCALE);
				ParseSubChunks(newEndPos, newLevel);
				break;
			//case CHUNK_TRACKPRESCALE:
			//	cout << "Chunk TrackPrescale detected" << endl;
			//	ReadTrack(CHUNK_TRACKPRESCALE);
			//	ParseSubChunks(newEndPos, newLevel);
			//	break;
			case CHUNK_TRACKPIVOT:
				//cout << "Chunk TrackPivot detected" << endl;
				ReadPivotPoint();
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRACKFOV:
				//cout << "Chunk TrackFOV detected" << endl;
				ReadTrack(CHUNK_TRACKFOV);
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRACKROLL:
				//cout << "Chunk TrackRoll detected" << endl;
				ReadTrack(CHUNK_TRACKROLL);
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRACKHOTSPOT:
				//cout << "Chunk TrackHotSpot detected" << endl;
				ReadTrack(CHUNK_TRACKHOTSPOT);
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_TRACKFALLOFF:
				//cout << "Chunk TrackFallOff detected" << endl;
				ReadTrack(CHUNK_TRACKFALLOFF);
				ParseSubChunks(newEndPos, newLevel);
				break;
			case CHUNK_OBJNUMBER:
				//cout << "Chunk ObjNumber detected" << endl;
				ReadObjNumber();
				ParseSubChunks(newEndPos, newLevel);
				break;
			default:
				//cout << "Unknown Chunk at " << mInputFile.tellg() << " offset" << endl;
				SkipChunk(chunk);
				//ParseSubChunks(newEndPos, newLevel);
				break;
		}
	}
	assert(PC == endPos);

	return true;
}

/*bool C3dsFileLoader::ParseChunks()
{
	if(!mInputFile.is_open())
		return false;
	if(mInputFile.eof())
		return false;

	chunk3ds	chunk;

	if(!ReadBlock((char*) &chunk, sizeof(chunk3ds)))
		return false;
	switch(chunk.Flag)
	{

	case CHUNK_RGBF:
		cout << "Chunk RGBF detected" << endl;
		ReadRGBF();
		ParseChunks();
		break;
	case CHUNK_RGBB:
		cout << "Chunk RGBB detected" << endl;
		ReadRGBB();
		ParseChunks();
		break;
	case CHUNK_MAIN:
		cout << "Chunk Main detected" << endl;
		ParseChunks();
		break;
	case CHUNK_OBJMESH:
		cout << "Chunk Object detected" << endl;
		ReadObjChunk();
		ParseChunks();
		break;
	case CHUNK_OBJBLOCK:
		cout << "Chunk Object Block detected" << endl;
		ReadObjBlock();
		cout << endl;
		ParseChunks();
		break;
	case CHUNK_TRIMESH:
		cout << "Chunk Trimesh detected" << endl;
		ReadTriMesh();
		ParseChunks();
		break;
	case CHUNK_VERTLIST:
		cout << "Chunk VertList detected at " << (PC - sizeof(chunk3ds)) << endl;
		ReadVertList();
		ParseChunks();
		break;
	case CHUNK_FACELIST:
		cout << "Chunk FaceList detected" << endl;
		ReadFaceList();
		ParseChunks();
		break;
	case CHUNK_FACEMAT:
		cout << "Chunk FaceMat detected" << endl;
		ReadFaceMat();
		ParseChunks();
		break;
	case CHUNK_MAPLIST:
		cout << "Chunk MapList detected" << endl;
		ReadMapList();
		ParseChunks();
		break;
	case CHUNK_SMOOLIST:
		cout << "Chunk SmoothList detected" << endl;
		ReadSmoothList(chunk.Size - sizeof(chunk3ds));
		ParseChunks();
		break;
	case CHUNK_TRMATRIX:
		cout << "Chunk TRMatrix detected" << endl;
		ReadTrMatrix();
		ParseChunks();
		break;
	case CHUNK_LIGHT:
		cout << "Chunk Light detected" << endl;
		ReadLight();
		ParseChunks();
		break;
	case CHUNK_SPOTLIGHT:
		cout << "Chunk SpotLight detected" << endl;
		ReadSpotLight();
		ParseChunks();
		break;
	case CHUNK_CAMERA:
		cout << "Chunk Camera detected" << endl;
		ReadCamera();
		ParseChunks();
		break;
	case CHUNK_MATERIAL:
		cout << "Chunk Material detected" << endl;
		ParseChunks();
		break;
	case CHUNK_MATNAME:
		cout << "Chunk MatName detected" << endl;
		ReadMatName();
		ParseChunks();
		break;
	case CHUNK_MAPFILE:
		cout << "Chunk MapFile detected" << endl;
		ReadMapFile();
		ParseChunks();
		break;
	case CHUNK_KEYFRAMER:
		cout << "Chunk Keyframer detected" << endl;
		ParseChunks();
		break;
	case CHUNK_TRACKINFO:
		cout << "Chunk TrackInfo detected" << endl;
		ParseChunks();
		break;
	case CHUNK_TRACKOBJNAME:
		cout << "Chunk TrackObjName detected" << endl;
		ReadTrackObjName();
		ParseChunks();
		break;
	case CHUNK_TRACKPOS:
		cout << "Chunk TrackPos detected" << endl;
		ReadTrackPos();
		ParseChunks();
		break;
	case CHUNK_TRACKROTATE:
		cout << "Chunk TrackRotate detected" << endl;
		ReadTrackRot();
		ParseChunks();
		break;
	case CHUNK_TRACKSCALE:
		cout << "Chunk TrackScale detected" << endl;
		ReadTrackScale();
		ParseChunks();
		break;
	case CHUNK_OBJNUMBER:
		cout << "Chunk ObjNumber detected" << endl;
		ReadObjNumber();
		ParseChunks();
		break;
	default:
		cout << "Unknown Chunk at " << mInputFile.tellg() << " offset" << endl;
		SkipChunk(chunk);
		ParseChunks();
		break;
	}
	return true;
}*/

bool C3dsFileLoader::SkipChunk(chunk3ds &chunk)
{
	PC += (chunk.Size - sizeof(chunk3ds));
	mInputFile.seekg(PC);
	if(mInputFile.eof())
		return false;
	return true;
}

void C3dsFileLoader::ProcessFile(string FileName)
{
	mInputFile.open(FileName.c_str(), ios::binary);	// ::binary for windows, ::in for linux.
	FileSize();
	if(mInputFile.is_open() == false)
	{
		cout << "failed to open input file: " << FileName << endl;
		return;
	}
	cout << "Opened input file: " << FileName << endl;
	ParseChunks();
	EndReading();
}

bool C3dsFileLoader::ReadBlock(char *dest, unsigned int size)
{	
	PC = mInputFile.tellg();
   if(!mInputFile.read(dest, size) && mInputFile.eof())
   	return false;
	PC += size;
	mInputFile.seekg(PC);
	return true;
}

bool C3dsFileLoader::isOk()
{
	if(!mInputFile.is_open())
		return false;
	if(mInputFile.eof())
		return false;
	return true;
}

void C3dsFileLoader::FileSize()
{
	// get length of file:
	mInputFile.seekg (0, ios::end);
	mFileSize = mInputFile.tellg();
	mInputFile.seekg (0, ios::beg);
}

void C3dsFileLoader::ReadASCIIZ(char *dest)
{
	char c;
	long Count = 0;
	do 
	{
		c = mInputFile.get();       // get character from file
		*dest++ = c;
		Count++;
	} while (c != 0);     // loop while extraction from file is possible
	PC+= Count;
	mInputFile.seekg(PC);
}
